#! /bin/sh

# Copyright (c) 2022 xFusion Digital Technologies Co., Ltd. All rights reserved.
# Description: zzz_history.sh
# Author: ChenYanpan
# Create: 2022-02-28

function system_history
{
    typeset result=$?
    typeset result_str=""
    if [ ${result} -eq 0 ];then
        result_str="return code=[0], execute success"
    else
        result_str="return code=[${result}], execute failed"
    fi
    history -a
    typeset user=$(whoami)
    typeset user_id=$(id -ur $user)
    typeset login=$(who -m | awk '{print $2" "$5}' | sed 's|[[:space:]]*$||g')
    typeset msg=$(history 1 | { read x y; echo "$y"; })
    typeset num=$(history 1 | { read x y; echo "$x"; })
    if [ "${num}" != "${LastComandNum_for_history}" ] && [ "${LastComandNum_for_history}" != "" -o "${num}" == "1" ];then
        logger -t "[${SHELL}]" "[${msg}]" "${result_str}" "by [${user}(uid=$user_id)] from [$login]"
    fi
    LastComandNum_for_history=${num}
}

function system_variable_readonly 
{
    typeset var="$1"
    typeset val="$2"
    typeset ret=$(readonly -p | grep -w "${var}" | awk -F "${var}=" '{print $NF}')
    if [ "${ret}" = "\"${val}\"" ]
    then
        return
    else
        export "${var}"="${val}"
        readonly "${var}"
    fi
}

export HISTCONTROL=''
system_variable_readonly HISTTIMEFORMAT ""
system_variable_readonly PROMPT_COMMAND system_history
